#include  <dos.h>
static	struct	SREGS	segregs;		/* segment register	*/
static	union 	REGS	inregs, outregs;	/* register variables	*/

lputs ( s )	/* v^o	*/
unsigned char	*s;
{
	inregs.h.ah = 0x30;
	inregs.x.bx = s;
	inregs.x.cx = strlen( s );
	int86x(0x1a, &inregs, &outregs, &segregs);
}

lputp (s, n)	/* v^óiFj*/
unsigned char	*s;
int		 n;
{
	inregs.h.ah = 0x30;
	inregs.x.bx = s;
	inregs.x.cx = n;
	int86x(0x1a, &inregs, &outregs, &segregs);
}

hcopy( n )	/* n[hRs[s	*/
int	n;
{
    int		i, k;
    static unsigned char cx[2080], cy[1280], len[5];

    segread( &segregs );
    lputs ( "\033D\033T16\r\n" );
    switch( n ) {
	case 1: /* TCY*/
	for( k=0; k<50 ; k=k+2 ) {
		read8(k, cy); read8(k+1, cy+640);	/* read 2 line	*/
		i = arrange2(cx, cy);		 /* rearrange to 2 line */
		if(i) {
			decstr(i, len, 4);
			lputs( "\033I" ); lputs( len ); lputp(cx, 2*i);
		}
		lputs ( "\r\n" );
	}
	break;

	case 2: /* TCY*/
	for( k=0; k<50 ; k++ ) {
		read8( k, cy );				/* read 1 line  */
		i = arrange4(cx, cy);		 /* rearrange to 4 line */
		if(i) {
			decstr(i, len, 4);
			lputs( "\033I" ); lputs( len ); lputp(cx, 2*i);
		}
		lputs ( "\r\n" );
	}
    }

    lputs ( "\033M\033A\r\n\r" );
}

read8(k, cy)		/* read 8-dots line */
int     k;
unsigned char  *cy;
{
	static unsigned char cx[640], *p, *q;
	/*  read vram  */
	movedata(0xa800, 640*k, segregs.ds, cy, 640);	/* blue */
	movedata(0xb000, 640*k, segregs.ds, cx, 640);	/* red  */
	for(p=cy, q=cx; p<cy+640; *p++ |= *q++);
	movedata(0xb800, 640*k, segregs.ds, cx, 640);	/* green*/
	for(p=cy, q=cx; p<cy+640; *p++ |= *q++);
}

arrange2(cx, cy)
unsigned char	*cx,*cy;
{
	unsigned char	*p, *q, *r, *e;
	unsigned char	i, m, x;
	/*  rearrange  2 line  */
	q = cx; e = cx;
	for(p=cy; p<cy+65; p++) {
		m = 0x80;
		for(i=0; i<8; i++) {
			x = 0;
			for(r=p    ; r<p+ 640; r+=80) {
				x >>= 1; if( *r&m ) x += 0x80;
			}
			*q++ = x;
			if(x) e = q;
			x = 0;
			for(r=p+640; r<p+1280; r+=80) {
				x >>= 1; if( *r&m ) x += 0x80;
			}
			*q++ = x;
			if(x) e = q;
			m >>= 1;
		}
	}
	return( (e-cx+1)/2 );
}

arrange4(cx, cy)
unsigned char	*cx,*cy;
{
	unsigned char	*p, *q, *r, *e;
	unsigned char	i, m, x;
	/*  rearrange  1 line to 4  */
	q = cx; e = cx;
	for(p=cy; p<cy+65; p++) {
		m = 0x80;
		for(i=0; i<8; i++) {
			x = 0;
			for(r=p    ; r<p+ 320; r+=80) {
				x >>= 1; if( *r&m ) x += 0x80;
				x >>= 1; if( *r&m ) x += 0x80;
			}
			q[2] = x;
			*q++ = x;
			if(x) e = q+2;
			x = 0;
			for(r=p+320; r<p+ 640; r+=80) {
				x >>= 1; if( *r&m ) x += 0x80;
				x >>= 1; if( *r&m ) x += 0x80;
			}
			q[2] = x;
			*q++ = x;
			if(x) e = q+2;
			q +=  2;
			m >>= 1;
		}
	}
	return( (e-cx+1)/2 );
}

decstr(n, s, c)		/* w蕶̕ɕϊ*/
int		n, c;
unsigned char	*s;
{
	int	i,j;
	i = c; s[c] = 0;
	while( i != 0 ) {
		i--;
		j  = n % 10;
		n = n / 10;
		s[i] = '0' + j;
	}
}

main()
{
	hcopy( 2 );
}
